<?php
/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2006
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * $Id: update.php 63 2006-06-14 22:30:35Z mathos $
 *
 ******************************/


//---[ Update File Downloader ]-----------------------------
if( isset($_POST['send_file']) && !empty($_POST['send_file']) && !empty($_POST['data']) )
{
	$file = $_POST['data'];

	header('Content-Type: text/x-delimtext; name="'.$_POST['send_file'].'_log.txt"');
	header('Content-disposition: attachment; filename="'.$_POST['send_file'].'_log.txt"');

	// We need to stripslashes no matter what the setting of magic_quotes_gpc is
	echo stripslashes($file);

	exit;
}


$subdir = '../';
require_once( $subdir.'settings.php' );
require_once( ROSTER_BASE.'lib'.DIR_SEP.'luaparser.php' );


// Update Triggers
if( $roster_conf['use_update_triggers'] )
	include_once( ROSTER_BASE.'lib'.DIR_SEP.'update_trigger_lib.php' );


if (!$roster_conf['authenticated_user'])
{
	$wow_group = $roster_conf['upload_group'];
	include_once( ROSTER_BASE.'lib'.DIR_SEP.'phpbb.php' );
}

// Set $htmlout to 1 to assume request is from a browser
	$htmlout = 1;
// See if UU is requesting this page
if( substr( $_SERVER['HTTP_USER_AGENT'], 0, 11 ) == 'UniUploader' )
{
	$htmlout = 0;
}
else
{
	// Set the sql debugger (outputs html comments of sql strings in addition to normal output)
	$wowdb->setSQLDebug($roster_conf['sqldebug']);
}


// Files that we accept for upload
$filefields[] = 'CharacterProfiler.lua';
$filefields[] = 'PvPLog.lua';

// Loop through each posted file
foreach ($_FILES as $filefield => $file)
{
	$filename = $file['tmp_name'];
	$filemode = '';

	if( substr_count($file['name'],'.gz') > 0 )	// If the file is gzipped
		$filemode = 'gz';

	foreach( $filefields as $acceptedfile )	// Itterate through all the possible filefields
	{
		if( $acceptedfile == $file['name'] || $acceptedfile.'.gz' == $file['name'] )
		{
			// Filefield is 1 of the kind we accept.
			if( $roster_conf['authenticated_user'] )
			{
				$uploadFound = true;

				// Parse the lua file into a php array that we can use
				$data = ParseLuaFile( $filename , $filemode );

				// If pvp data is there, assign it to $uploadData['PvpLogData']
				if( isset($data['PurgeLogData']) )
				{
					$uploadData['PvpLogData'] = $data;
				}

				// If CP data is there, assign it to $uploadData['myProfile']
				if( isset($data['myProfile']) )
				{
					$uploadData['myProfile'] = $data['myProfile'];
				}
				// Clear the $data variable
				unset($data);
			}
		}
	}
	@unlink($filename);	// Done with the file, we don't need it anymore
}


// If the roster update password is sent and matches, and $uploadData['myProfile'] is there, update the roster
if( is_array($uploadData['myProfile']) && isset($_POST['password']) )
{
	if( (md5($_POST['password']) == $roster_conf['roster_upd_pw']) || ($_POST['password'] == $roster_conf['roster_upd_pw']) )
	{
		$rosterUpdateMessages = processGuildRoster($uploadData['myProfile']);
	}
}

if( is_array($uploadData['myProfile']) )
{
	$updateMessages = processMyProfile($uploadData['myProfile']);
}

if( is_array($uploadData['PvpLogData']) )
{
	$updatePvPMessages = processPvP($uploadData['PvpLogData']);
}

function processPvP($pvpdata)
{
	global $wowdb, $roster_conf, $wordings;

	$wowdb->resetMessages();

	foreach ($pvpdata['PurgeLogData'] as $realm_name => $realm)
	{
		foreach ($realm as $char_name => $char)
		{
			if ($wowdb->num_rows($result) > 0)
			{
				$battles = $char['battles'];
				if( $char['version'] >= $roster_conf['minPvPLogver'] )
				{
					$output .= "<strong>Updating PvP Data for [<span class=\"orange\">$char_name</span>]</strong>\n";

					$wowdb->update_pvp2($char_name, $battles);
					$output .= "<ul>\n".$wowdb->getMessages()."</ul>\n";
					$wowdb->resetMessages();
				}
				else // PvPLog version not high enough
				{
					$output .= "<span class=\"red\">NOT Updating PvP for [$char_name] - ".$char['version']."</span><br />\n";
					$output .= $wordings[$roster_conf['roster_lang']]['PvPLogver_err']."\n";
				}
			}
		}
	}
	return $output;
}

function processMyProfile($myProfile)
{
	global $wowdb, $roster_conf, $wordings;

	$wowdb->resetMessages();

	foreach( array_keys( $myProfile ) as $realm_name )
	{
		$realm = $myProfile[$realm_name];
		foreach( array_keys( $realm ) as $char_name )
		{
			if ($char_name != 'Guild')
			{
						$char = $realm[$char_name];

						// CP Version Detection, don't allow lower than minVer
						if( $char['DBversion'] >= $roster_conf['minCPver'] )
						{
							// take the current time and get the offset. Upload must occur same day that roster was obtained
							list($month, $day, $year, $hour, $minute, $second) = sscanf($char['DateUTC'],"%d/%d/%d %d:%d:%d");
							$currentTimestamp = mktime(intval($hour),intval($minute),0);
							
							$output .= "<strong>Updating Character [<span class=\"orange\">$char_name</span>]</strong>\n";
							
							$wowdb->update_member($char_name,$realm_name,$char,$currentTimestamp );
							$wowdb->update_char($char_name,$realm_name, $char );
							$output .= "<ul>\n".$wowdb->getMessages()."</ul>\n";
							$wowdb->resetMessages();

							// Start update triggers
							if( $roster_conf['use_update_triggers'] )
							{
								$output .= start_update_trigger($char_name,'char');
							}
						}
						else // CP Version not new enough
						{
							$output .= "<span class=\"red\">NOT Updating character [$char_name]</span><br />\n";
							$output .= "Data is from CharacterProfiler v".$char['DBversion']."<br />\n";
							$output .= $wordings[$roster_conf['roster_lang']]['CPver_err']."\n";
						}
					}
			}
			$output .= "<br />\n";
	}
	return $output;
}

// Create the PvPLog input field if selected in conf
if( $roster_conf['pvp_log_allow'] )
{
	$pvplogInputField = "
                    <tr>
                      <td class=\"membersRow2\" onmouseover=\"overlib('<b>PvPLog.lua</b> ".$wordings[$roster_conf['roster_lang']]['filelocation']."\\\\PvPLog.lua',WRAP,RIGHT);\" onmouseout=\"return nd();\">PvPLog.lua</td>
                      <td class=\"membersRowRight2\"><input type=\"file\" accept=\"PvPLog.lua\" name=\"PvPLog\"></td>
                    </tr>";
}


// Construct the entire upload form
$inputForm = "
                <form action=\"update.php\" enctype=\"multipart/form-data\" method=\"POST\" onsubmit=\"submitonce(this)\">
$authFields
".border('syellow','start','Upload Files')."
                  <table class=\"bodyline\" cellspacing=\"0\" cellpadding=\"0\">
                    <tr>
                      <td class=\"membersRowRight1\" colspan=\"2\" align=\"center\"><div align=\"center\"><small>".$wordings[$roster_conf['roster_lang']]['lualocation']."</small></div></td>
                    </tr>
                    <tr>
                      <td class=\"membersRow2\" onmouseover=\"overlib('<b>CharacterProfiler.lua</b> ".$wordings[$roster_conf['roster_lang']]['filelocation']."\\\\CharacterProfiler.lua',WRAP,RIGHT);\" onmouseout=\"return nd();\">CharacterProfiler.lua</td>
                      <td class=\"membersRowRight2\"><input type=\"file\" accept=\"CharacterProfiler.lua\" name=\"CharacterProfiler\"></td>
                    </tr>
$pvplogInputField
                    <tr>
                      <td class=\"membersRowRight1\" colspan=\"2\" align=\"center\"><div align=\"center\"><input type=\"submit\" value=\"".$wordings[$roster_conf['roster_lang']]['upload']."\"></div></td>
                    </tr>
                  </table>
".border('syellow','end')."
<br />
                </form>";


// Construct our page

// Get SQL messages
$sqlstringout = $wowdb->getSQLStrings();
$errorstringout = $wowdb->getErrors();


if( $htmlout )
{
	include_once(ROSTER_BASE.'roster_header.tpl');
	include_once(ROSTER_BASE.'lib'.DIR_SEP.'menu.php');
	print '<span class="title_text">'.$wordings[$roster_conf['roster_lang']]['update_page']."</span><br /><br />\n";

	if( $uploadFound )
	{
		// print the error messages
		if( !empty($errorstringout) )
		{
			print
			'<div id="errorCol" style="display:inline;">
				'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$subdir.$roster_conf['img_url']."plus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").'
				'.border('sred','end').'
			</div>
			<div id="error" style="display:none">
			'.border('sred','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('errorCol','error')\"><img src=\"".$subdir.$roster_conf['img_url']."minus.gif\" style=\"float:right;\" /><span class=\"red\">Update Errors</span></div>").
			$errorstringout.
			border('sred','end').
			'</div>';

			// Print the downloadable errors separately so we can generate a download
			print "<br />\n";
			print '<form method="post" action="update.php" name="post">'."\n";
			print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($errorstringout)).'" />'."\n";
			print '<input type="hidden" name="send_file" value="error" />'."\n";
			print '<input type="submit" name="download" value="Save Error Log" />'."\n";
			print '</form>';
			print "<br />\n";
		}

		// Print the update messages
		print
			border('syellow','start','Update Log').
			'<div style="font-size:10px;background-color:#1F1E1D;text-align:left;height:300px;width:550px;overflow:auto;">'.
				$updateMessages.
				$updatePvPMessages.
				$rosterUpdateMessages.
			'</div>'.
			border('syellow','end');

		// Print the downloadable messages separately so we can generate a download
		print "<br />\n";
		print '<form method="post" action="update.php" name="post">'."\n";
		print '<input type="hidden" name="data" value="'.htmlspecialchars(stripAllHtml($updateMessages.$updatePvPMessages.$rosterUpdateMessages)).'" />'."\n";
		print '<input type="hidden" name="send_file" value="update" />'."\n";
		print '<input type="submit" name="download" value="Save Update Log" />'."\n";
		print '</form>';
		print "<br />\n";


		// Print the SQL Messages
		if( $roster_conf['sqldebug'] )
		{
			print
			'<div id="sqlDebugCol" style="display:inline;">
				'.border('sgray','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('sqlDebugCol','sqlDebug')\"><img src=\"".$subdir.$roster_conf['img_url']."plus.gif\" style=\"float:right;\" />SQL Queries</div>").'
				'.border('sgray','end').'
			</div>
			<div id="sqlDebug" style="display:none">
			'.border('sgreen','start',"<div style=\"cursor:pointer;width:550px;\" onclick=\"swapShow('sqlDebugCol','sqlDebug')\"><img src=\"".$subdir.$roster_conf['img_url']."minus.gif\" style=\"float:right;\" />SQL Queries</div>").'
			<div style="font-size:10px;background-color:#1F1E1D;text-align:left;height:300px;width:560px;overflow:auto;">'.
				nl2br(sql_highlight($sqlstringout)).
			'</div>
			'.border('sgreen','end').
			'</div>';


			// Print the downloadable sql separately so we can generate a download
			print "<br />\n";
			print '<form method="post" action="update.php" name="post">'."\n";
			print '<input type="hidden" name="data" value="'.htmlspecialchars($sqlstringout).'" />'."\n";
			print '<input type="hidden" name="send_file" value="sql" />'."\n";
			print '<input type="submit" name="download" value="Save SQL Log" />'."\n";
			print '</form>';
		}
	}
	else
	{
		print $inputForm;
	}

	include_once(ROSTER_BASE.'roster_footer.tpl');
}
else	// Dont need the header and footer when responding to UU
{
	if( $uploadFound )
	{
		// Strip all html tags out, then print
		print stripAllHtml(
				$auth_message.
				$updateMessages.
				$updatePvPMessages.
				$rosterUpdateMessages
			);

	}
	else
	{
		// Weren't any files in the upload that correspond to anything in the array of filefields that we take.
		print $wordings[$roster_conf['roster_lang']]['nofileUploaded'];
	}
}

?>